import hashlib
import hmac

def verify_slack_signature(slack_post_request, slack_signing_secret):
    slack_signing_secret = bytes(slack_signing_secret, 'utf-8')
    slack_signature = slack_post_request['headers']['X-Slack-Signature']
    slack_request_timestamp = slack_post_request['headers']['X-Slack-Request-Timestamp']
    request_body = slack_post_request["body"]

    basestring = f"v0:{slack_request_timestamp}:{request_body}".encode('utf-8')
    my_signature = 'v0=' + hmac.new(slack_signing_secret, basestring, hashlib.sha256).hexdigest()

    return hmac.compare_digest(my_signature, slack_signature)




event = {'resource': '/release', 'path': '/index-signoff/release', 'httpMethod': 'POST', 'headers': {'Accept': 'application/json,*/*', 'Accept-Encoding': 'gzip,deflate', 'CloudFront-Forwarded-Proto': 'https', 'CloudFront-Is-Desktop-Viewer': 'true', 'CloudFront-Is-Mobile-Viewer': 'false', 'CloudFront-Is-SmartTV-Viewer': 'false', 'CloudFront-Is-Tablet-Viewer': 'false', 'CloudFront-Viewer-Country': 'US', 'Content-Type': 'application/x-www-form-urlencoded', 'Host': 'api.labelinsight.com', 'User-Agent': 'Slackbot 1.0 (+https://api.slack.com/robots)', 'Via': '1.1 c1b581c57bf4a6612b8a88bfe89e4ea0.cloudfront.net (CloudFront)', 'X-Amz-Cf-Id': 'kSYxI4j7J1GMXgwJeOXVddBhMKItssr0yQ3CWwPqXYpWwMgE8GmtNA==', 'X-Amzn-Trace-Id': 'Root=1-5d48492a-1acb2124f364ec0caca5c088', 'X-Forwarded-For': '3.82.52.85, 70.132.59.154', 'X-Forwarded-Port': '443', 'X-Forwarded-Proto': 'https', 'X-Slack-Request-Timestamp': '1565018410', 'X-Slack-Signature': 'v0=6dd420aede59cb8b5418493c3c0dc8d354295c2ffd0ce9b18e2ef42d005bd67c'}, 'multiValueHeaders': {'Accept': ['application/json,*/*'], 'Accept-Encoding': ['gzip,deflate'], 'CloudFront-Forwarded-Proto': ['https'], 'CloudFront-Is-Desktop-Viewer': ['true'], 'CloudFront-Is-Mobile-Viewer': ['false'], 'CloudFront-Is-SmartTV-Viewer': ['false'], 'CloudFront-Is-Tablet-Viewer': ['false'], 'CloudFront-Viewer-Country': ['US'], 'Content-Type': ['application/x-www-form-urlencoded'], 'Host': ['api.labelinsight.com'], 'User-Agent': ['Slackbot 1.0 (+https://api.slack.com/robots)'], 'Via': ['1.1 c1b581c57bf4a6612b8a88bfe89e4ea0.cloudfront.net (CloudFront)'], 'X-Amz-Cf-Id': ['kSYxI4j7J1GMXgwJeOXVddBhMKItssr0yQ3CWwPqXYpWwMgE8GmtNA=='], 'X-Amzn-Trace-Id': ['Root=1-5d48492a-1acb2124f364ec0caca5c088'], 'X-Forwarded-For': ['3.82.52.85, 70.132.59.154'], 'X-Forwarded-Port': ['443'], 'X-Forwarded-Proto': ['https'], 'X-Slack-Request-Timestamp': ['1565018410'], 'X-Slack-Signature': ['v0=6dd420aede59cb8b5418493c3c0dc8d354295c2ffd0ce9b18e2ef42d005bd67c']}, 'queryStringParameters': None, 'multiValueQueryStringParameters': None, 'pathParameters': None, 'stageVariables': None, 'requestContext': {'resourceId': '8jdmea', 'resourcePath': '/release', 'httpMethod': 'POST', 'extendedRequestId': 'd9BenFkTIAMF2Jg=', 'requestTime': '05/Aug/2019:15:20:10 +0000', 'path': '/index-signoff/release', 'accountId': '257111400340', 'protocol': 'HTTP/1.1', 'stage': 'prod', 'domainPrefix': 'api', 'requestTimeEpoch': 1565018410355, 'requestId': '83aa9cc7-b794-11e9-8a2a-85dd20945272', 'identity': {'cognitoIdentityPoolId': None, 'accountId': None, 'cognitoIdentityId': None, 'caller': None, 'sourceIp': '3.82.52.85', 'principalOrgId': None, 'accessKey': None, 'cognitoAuthenticationType': None, 'cognitoAuthenticationProvider': None, 'userArn': None, 'userAgent': 'Slackbot 1.0 (+https://api.slack.com/robots)', 'user': None}, 'domainName': 'api.labelinsight.com', 'apiId': 'q7aj5n51l0'}, 'body': 'payload=%7B%22type%22%3A%22interactive_message%22%2C%22actions%22%3A%5B%7B%22name%22%3A%22approve%22%2C%22type%22%3A%22button%22%2C%22value%22%3A%22approve%22%7D%5D%2C%22callback_id%22%3A%22call_back_id%22%2C%22team%22%3A%7B%22id%22%3A%22T02GF4C6J%22%2C%22domain%22%3A%22labelinsight%22%7D%2C%22channel%22%3A%7B%22id%22%3A%22C02PVRNL8%22%2C%22name%22%3A%22index%22%7D%2C%22user%22%3A%7B%22id%22%3A%22U04PS5Z6A%22%2C%22name%22%3A%22akling%22%7D%2C%22action_ts%22%3A%221565018410.261762%22%2C%22message_ts%22%3A%221564897384.023700%22%2C%22attachment_id%22%3A%221%22%2C%22token%22%3A%22qkTtEilyhF8rCCq28dvfT6Zo%22%2C%22is_app_unfurl%22%3Afalse%2C%22original_message%22%3A%7B%22type%22%3A%22message%22%2C%22subtype%22%3A%22bot_message%22%2C%22text%22%3A%22Indexing+is+ready+to+be+released.%22%2C%22ts%22%3A%221564897384.023700%22%2C%22bot_id%22%3A%22BJ7MRLDUZ%22%2C%22attachments%22%3A%5B%7B%22callback_id%22%3A%22call_back_id%22%2C%22fallback%22%3A%22You+are+unable+to+decide%3F+What+kind+of+leader+are+you%3F%22%2C%22text%22%3A%22Just+like+Caesar%2C+thumbs+up+or+down%3F%22%2C%22id%22%3A1%2C%22color%22%3A%225EBDEF%22%2C%22actions%22%3A%5B%7B%22id%22%3A%221%22%2C%22name%22%3A%22approve%22%2C%22text%22%3A%22Approve+%3Athumbsup%3A%22%2C%22type%22%3A%22button%22%2C%22value%22%3A%22approve%22%2C%22style%22%3A%22primary%22%2C%22confirm%22%3A%7B%22text%22%3A%22This+will+APPROVE+the+indexing+operation%22%2C%22title%22%3A%22Are+you+sure%3F%22%2C%22ok_text%22%3A%22Yes%22%2C%22dismiss_text%22%3A%22No%22%7D%7D%2C%7B%22id%22%3A%222%22%2C%22name%22%3A%22decline%22%2C%22text%22%3A%22Decline+%3Athumbsdown%3A%22%2C%22type%22%3A%22button%22%2C%22value%22%3A%22decline%22%2C%22style%22%3A%22danger%22%2C%22confirm%22%3A%7B%22text%22%3A%22This+will+decline+the+indexing+operation%22%2C%22title%22%3A%22Are+you+sure%3F%22%2C%22ok_text%22%3A%22Yes%22%2C%22dismiss_text%22%3A%22No%22%7D%7D%5D%7D%5D%7D%2C%22response_url%22%3A%22https%3A%5C%2F%5C%2Fhooks.slack.com%5C%2Factions%5C%2FT02GF4C6J%5C%2F716500681744%5C%2FEp6xf71LBmzRN6kBylQErO3v%22%2C%22trigger_id%22%3A%22710165475745.2559148222.5e644de2cc327fcc53bbf7d7bf464320%22%7D', 'isBase64Encoded': False}
sig = "2193e0bddf64bbc0cc1054dc3d703d5e"

print(verify_slack_signature(event, sig))
